%% errorprob.pl  -- Hans-Peter Stoerr Fri Nov 14 2003
%% $Id: errorprob.pl,v 1.2 2003/11/17 07:01:06 stoerr Exp $
%% $Log: errorprob.pl,v $
%% Revision 1.2  2003/11/17 07:01:06  stoerr
%% Seems to work.
%%
%% Revision 1.1  2003/11/14 15:45:40  stoerr
%% first part seems to work.
%%
%%

%% m(k,n,h,X) X is the number of possibilities to put k items into n pockets,
%% such that in each pocket there are at most h items.
%% done with dynamic programming.

:- dynamic mmem/4.
% :- retractall(mmem(_,_,_,_)).

m(K,_,_,0) :- K < 0, !.
m(_,N,_,0) :- N < 0, !.
m(_,_,H,0) :- H < 0, !.
m(_,1,_,1) :- !.
m(0,_,_,1) :- !.
m(_,0,_,0) :- !.
m(K,N,3,X) :- mmem(K,N,3,X).
m(K,N,3,X) :- N1 is N-1, K1 is K-1, K2 is K-2, K3 is K-3,
        m(K3,N1,3,X3), m(K2,N1,3,X2), m(K1,N1,3,X1), m(K,N1,3,X0),
        X is X0+X1+X2+X3, assert(mmem(K,N,3,X)).

%% crep(k,n,X) is the number of possibilities to put k items into n pockets.
%% combinations with repeats: (n+k-1) over k

crep(K,N,X) :- Nx is N+K-1, over(Nx,K,X).

over(_,0,1) :- !.
over(N,K,X) :- K1 is K-1, over(N,K1,X1), X is X1*(N-K+1)/K.

fak(0,1).
fak(1,1).
fak(K,F) :- K1 is K-1, fak(K1,F1), F is F1*K.

%% probability that k errors in n hyperblocks are correctable. I.e.
%% prob. that at most 3 errors are in one hyperblock.

c3(K,N,P) :- m(K,N,3,Corr), crep(K,N,All), !, P is Corr/All.
