/** hyperblkcodec.h -*- c++ -*- Hans-Peter Stoerr Fri Nov  7 2003 */
/// construct error protection information and
/// reconstruct errorneous block from error protection information
/// for a number of blklen byte sized blocks.
/// hblen blocks of size blklen bytes have hbcorr error protection blocks.
/// $Id: hyperblkcodec.h,v 1.3 2003/12/29 18:06:31 stoerr Exp $

#ifndef _HYPERBLKCODEC_H
#define _HYPERBLKCODEC_H

#include "options.h"

/// write error protection info 
/// blks: blocks to protect, hblen*blklen bytes
/// protblks: protection info, hbcorr*blklen bytes
void hyperblockprotect(const char* blks, char* protblks);

/// reconstruct blocks with error protection info 
/// blks: blocks to correct, hblen*blklen bytes
/// protblks: protection info, hbcorr*blklen bytes
/// corrects blks; returns true iff block could be corrected or is errorfree.
bool hyperblockcorrect(char* blks, const char* protblks);

#endif
